/*----- PROTECTED REGION ID(BacnetConfClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        BacnetConfClass.h
//
// description : Include for the BacnetConf root class.
//               This class is the singleton class for
//                the BacnetConf device class.
//               It contains all properties and methods which the
//               BacnetConf requires only once e.g. the commands.
//
// project :     BacnetConf
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef BacnetConfClass_H
#define BacnetConfClass_H

#include <tango/tango.h>
#include "BacnetConf.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConfClass.h


namespace BacnetConf_ns
{
/*----- PROTECTED REGION ID(BacnetConfClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConfClass::classes for dynamic creation

//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute dynScalarFloatRO class definition
class dynScalarFloatROAttrib: public Tango::Attr
{
public:
	dynScalarFloatROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_FLOAT, Tango::READ) {};
	~dynScalarFloatROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarFloatRO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarFloatRO_allowed(ty);}
};

//	Attribute dynScalarInt16RO class definition
class dynScalarInt16ROAttrib: public Tango::Attr
{
public:
	dynScalarInt16ROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_SHORT, Tango::READ) {};
	~dynScalarInt16ROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarInt16RO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarInt16RO_allowed(ty);}
};

//	Attribute dynScalarInt32RO class definition
class dynScalarInt32ROAttrib: public Tango::Attr
{
public:
	dynScalarInt32ROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_LONG, Tango::READ) {};
	~dynScalarInt32ROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarInt32RO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarInt32RO_allowed(ty);}
};

//	Attribute dynScalarByteRO class definition
class dynScalarByteROAttrib: public Tango::Attr
{
public:
	dynScalarByteROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_UCHAR, Tango::READ) {};
	~dynScalarByteROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarByteRO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarByteRO_allowed(ty);}
};

//	Attribute dynScalarBoolRO class definition
class dynScalarBoolROAttrib: public Tango::Attr
{
public:
	dynScalarBoolROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~dynScalarBoolROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarBoolRO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarBoolRO_allowed(ty);}
};

//	Attribute dynScalarDoubleRO class definition
class dynScalarDoubleROAttrib: public Tango::Attr
{
public:
	dynScalarDoubleROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_DOUBLE, Tango::READ) {};
	~dynScalarDoubleROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarDoubleRO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarDoubleRO_allowed(ty);}
};

//	Attribute dynScalarUInt32RO class definition
class dynScalarUInt32ROAttrib: public Tango::Attr
{
public:
	dynScalarUInt32ROAttrib(const std::string &att_name):Attr(att_name.c_str(),
			Tango::DEV_ULONG, Tango::READ) {};
	~dynScalarUInt32ROAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<BacnetConf *>(dev))->read_dynScalarUInt32RO(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<BacnetConf *>(dev))->is_dynScalarUInt32RO_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command FindName class definition
class FindNameClass : public Tango::Command
{
public:
	FindNameClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	FindNameClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~FindNameClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<BacnetConf *>(dev))->is_FindName_allowed(any);}
};

//	Command FindObjects class definition
class FindObjectsClass : public Tango::Command
{
public:
	FindObjectsClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	FindObjectsClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~FindObjectsClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<BacnetConf *>(dev))->is_FindObjects_allowed(any);}
};


/**
 *	The BacnetConfClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  BacnetConfClass : public Tango::DeviceClass
#else
class BacnetConfClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(BacnetConfClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConfClass::Additional DServer data members

	public:
		//	Class properties data members
		//	Name_Map_File:	Filename where device-id, object-identifier, object-name map is stored
		std::string	name_Map_File;
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static BacnetConfClass *init(const char *);
		static BacnetConfClass *instance();
		~BacnetConfClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		BacnetConfClass(std::string &);
		static BacnetConfClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	BacnetConf_H
